=== debian/changelog ===
ros-indigo-oculus-sdk (0.2.6-0trusty) trusty; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Devon Ash <dash@clearpathrobotics.com>  Thu, 03 Sep 2015 16:32:40 -0000

ros-indigo-oculus-sdk (0.2.4-0trusty) trusty; urgency=high

  * Merge pull request #3 <https://github.com/ros-visualization/oculus_sdk/issues/3> from hgaiser/hydro-devel
    Compile fix for OSX
  * Correction to CMakeLists.txt for WorldDemo
  * Compile fix for OSX
  * install package.xml
  * Contributors: David Gossow, Hans Gaiser, William Woodall

 -- Devon Ash <dash@clearpathrobotics.com>  Wed, 11 Feb 2015 05:00:00 -0000
